Loading...
Searching...
No Matches
Sip_content_language

## Macros

#define | sip_content_language(sip)
| Access a SIP Content-Language header structure sip_content_language_t from sip_t.
#define | SIP_CONTENT_LANGUAGE_INIT()
| Initializer for structure sip_content_language_t.
#define | SIPTAG_CONTENT_LANGUAGE(x)
| Tag list item for pointer to a Content-Language header structure sip_content_language_t.
#define | SIPTAG_CONTENT_LANGUAGE_REF(x)
| Tag list item for reference to a Content-Language header pointer.
#define | SIPTAG_CONTENT_LANGUAGE_STR(s)
| Tag list item for string with Content-Language header value.
#define | SIPTAG_CONTENT_LANGUAGE_STR_REF(x)
| Tag list item for reference to a Content-Language header string.

## Typedefs

typedef msg_list_t | sip_content_language_t
| @

## Functions

issize_t | sip_content_language_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Content-Language header.
issize_t | sip_content_language_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Content-Language header.
sip_content_language_t * | sip_content_language_init (sip_content_language_t x[1])
| Initialize a structure sip_content_language_t.
int | sip_is_content_language (sip_header_t const *header)
| Test if header object is instance of sip_content_language_t.
sip_content_language_t * | sip_content_language_dup (su_home_t *home, sip_content_language_t const *hdr))
| Duplicate a list of Content-Language header header structures sip_content_language_t.
sip_content_language_t * | sip_content_language_copy (su_home_t *home, sip_content_language_t const *hdr))
| Copy a list of Content-Language header header structures sip_content_language_t.
sip_content_language_t * | sip_content_language_make (su_home_t *home, char const *s))
| Make a Content-Language header structure sip_content_language_t.
sip_content_language_t * | sip_content_language_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Language header from formatting result.

## Variables

msg_hclass_t | sip_content_language_class []
| Header class for Content-Language header.
tag_typedef_t | siptag_content_language
| Tag for Content-Language header object.
tag_typedef_t | siptag_content_language_str
| Tag for string with Content-Language header value.

## Detailed Description

## Macro Definition Documentation

## SIP_CONTENT_LANGUAGE_INIT

#define SIP_CONTENT_LANGUAGE_INIT | ( |  | ) |

Initializer for structure sip_content_language_t.

A static sip_content_language_t structure for Content-Language header must be initialized with the SIP_CONTENT_LANGUAGE_INIT() macro. For instance,

sip_content_language_t sip_content_language = SIP_CONTENT_LANGUAGE_INIT;
sip_content_language_t
msg_list_t sip_content_language_t
@
Definition sip.h:153
sip_content_language
#define sip_content_language(sip)
Access a SIP Content-Language header structure sip_content_language_t from sip_t.
Definition sip_protos.h:15363
SIP_CONTENT_LANGUAGE_INIT
#define SIP_CONTENT_LANGUAGE_INIT()
Initializer for structure sip_content_language_t.
Definition sip_protos.h:15380

## SIPTAG_CONTENT_LANGUAGE

#define SIPTAG_CONTENT_LANGUAGE | ( |  | x | ) |

Tag list item for pointer to a Content-Language header structure sip_content_language_t.

The SIPTAG_CONTENT_LANGUAGE() macro is used to include a tag item with a pointer to a sip_content_language_t structure in a tag list.

Parameters

  x | pointer to a sip_content_language_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_CONTENT_LANGUAGE_REF().

## SIPTAG_CONTENT_LANGUAGE_STR

#define SIPTAG_CONTENT_LANGUAGE_STR | ( |  | s | ) |

Tag list item for string with Content-Language header value.

The SIPTAG_CONTENT_LANGUAGE_STR() macro is used to include a tag item with a string containing value of a sip_content_language_t header in a tag list.

Parameters

  s | pointer to a string containing Content-Language header value, or NULL.

The string in SIPTAG_CONTENT_LANGUAGE_STR() can be converted to a sip_content_language_t header structure by giving the string s has second argument to function sip_content_language_make().

The corresponding tag taking reference parameter is SIPTAG_CONTENT_LANGUAGE_STR_REF().

## Typedef Documentation

## sip_content_language_t

typedef msg_list_t sip_content_language_t

@

The Content-Language header RFC 2616 section 14.12 describes the natural language(s) of the intended audience for the enclosed entity. Note that this might not be equivalent to all the languages used within the entity-body. Its syntax is defined in RFC 3261 as follows:

Content-Language = "Content-Language" HCOLON
language-tag *(COMMA language-tag)
language-tag = primary-tag *( "-" subtag )
primary-tag = 1*8ALPHA
subtag = 1*8ALPHA
ALPHA
#define ALPHA

The parsed Content-Language header is stored in sip_content_language_t structure.

The structure sip_content_language_t contains representation of Content-Language header.

The sip_content_language_t is defined as follows:

typedef struct {
msg_common_t k_common[1]; // Common fragment info
msg_content_language_t *k_next; // (Content-Encoding header)
msg_param_t *k_items; // List of languages
} sip_content_language_t;
msg_content_language_t
msg_list_t msg_content_language_t
msg_common_t
struct msg_common_s msg_common_t

## Function Documentation

## sip_content_language_copy()

sip_content_language_t * sip_content_language_copy | ( | su_home_t * | home,
|  | sip_content_language_t const * | hdr )

inline

Copy a list of Content-Language header header structures sip_content_language_t.

The function sip_content_language_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  content_language = sip_content_language_copy(home, sip->sip_content_language);
  sip_content_language_copy
  sip_content_language_t * sip_content_language_copy(su_home_t *home, sip_content_language_t const *hdr))
  Copy a list of Content-Language header header structures sip_content_language_t.
  Definition sip_protos.h:15510

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_content_language_dup()

sip_content_language_t * sip_content_language_dup | ( | su_home_t * | home,
|  | sip_content_language_t const * | hdr )

inline

Duplicate a list of Content-Language header header structures sip_content_language_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_language = sip_content_language_dup(home, sip->sip_content_language);
  sip_content_language_dup
  sip_content_language_t * sip_content_language_dup(su_home_t *home, sip_content_language_t const *hdr))
  Duplicate a list of Content-Language header header structures sip_content_language_t.
  Definition sip_protos.h:15467

Returns
  A pointer to the newly duplicated sip_content_language_t header structure, or NULL upon an error.

## sip_content_language_format()

sip_content_language_t * sip_content_language_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Language header from formatting result.

Make a new sip_content_language_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_content_language_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_content_language_init()

sip_content_language_t * sip_content_language_init | ( | sip_content_language_t | x[1] | ) |

inline

Initialize a structure sip_content_language_t.

An sip_content_language_t structure for Content-Language header can be initialized with the sip_content_language_init() function/macro. For instance,

sip_content_language_t sip_content_language;
sip_content_language_init(&sip_content_language);
sip_content_language_init
sip_content_language_t * sip_content_language_init(sip_content_language_t x[1])
Initialize a structure sip_content_language_t.
Definition sip_protos.h:15398

## sip_content_language_make()

sip_content_language_t * sip_content_language_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Content-Language header structure sip_content_language_t.

The function sip_content_language_make() makes a new sip_content_language_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_content_language_t header structure, or NULL upon an error.

## sip_is_content_language()

int sip_is_content_language | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_content_language_t.

Check if the header class is an instance of Content-Language header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header content_language
  0 | (false) otherwise

## Variable Documentation

## sip_content_language_class

msg_hclass_t sip_content_language_class[]

extern

Header class for Content-Language header.

The header class sip_content_language_class defines how a SIP Content-Language header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_content_language_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.